using Bp.Sync.BackEnd.Application.Commands.FcBusinesses.Products.ProductSummaries;
using Bp.Sync.BackEnd.Infrastructure.Repositories.Davs;
using Bp.Sync.Domain.Elastics.Davs;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;

namespace Bp.Sync.BackEnd.Application.Commands.Davs.Storages
{
    public class SyncProductStorageDavHandler : MediatR.IRequestHandler<SyncProductStorageDavCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IProductStorageDavRepository _ProductStorageDavRepository;
        private readonly IBus _bus;

        public SyncProductStorageDavHandler(IConfiguration configuration, IProductStorageDavRepository ProductStorageDavRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("FcSyncDavConnection");
            _dbConnection = new SqlConnection(connectionString);
            _ProductStorageDavRepository = ProductStorageDavRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncProductStorageDavCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 10000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 10000; i++)
                    {
                        if (length > i * 10000)
                        {
                            var ids = request.Ids.Skip(i * 10000).Take(10000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticProductStorageDav", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} ProductStorageDavs" };
            }
            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Result.Success;
                return rs;
            }

            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var items = await _dbConnection.QueryAsync<ProductStorageDavElastic>("Sync_ProductStorageDav_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (items.Any())
                {
                    foreach (var item in items)
                    {
                    }

                    var rs2 = await _ProductStorageDavRepository.AddManyAsync(items);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_ProductStorageDav_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{items.Count()} synced";
                        rs.Result = Result.Success;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}